︠eca97e0b-bda1-40ca-950c-baceeec1176ei︠
%html
<h1>Binary Tree Sorting</h1>
<p><strong><em><a title="Applied Discrete Structures " href=" http://faculty.uml.edu/klevasseur/ads2" target="_blank">Applied Discrete Structures</a> </em>by Alan Doerr &amp; Kenneth Levasseur is licensed under a Creative Commons Attribution - Noncommercial - &nbsp;No Derivative Works 3.0 United States License.</strong></p>
<p>For more information on the algorithm, see <a href="http://faculty.uml.edu/klevasseur/ads/s-binary-trees.html">Section 10.4 of Applied Discrete Structures</a>.  This is really all Python, although it's evaluated in Sage.</p>
︡7acd8ed2-1345-4244-9ec2-0ad23024cad7︡{"done":true,"html":"<h1>Binary Tree Sorting</h1>\n<p><strong><em><a title=\"Applied Discrete Structures \" href=\" http://faculty.uml.edu/klevasseur/ads2\" target=\"_blank\">Applied Discrete Structures</a> </em>by Alan Doerr &amp; Kenneth Levasseur is licensed under a Creative Commons Attribution - Noncommercial - &nbsp;No Derivative Works 3.0 United States License.</strong></p>\n<p>For more information on the algorithm, see <a href=\"http://faculty.uml.edu/klevasseur/ads/s-binary-trees.html\">Section 10.4 of Applied Discrete Structures</a>.  This is really all Python, although it's evaluated in Sage.</p>"}
︠c4820990-e3e2-4df8-8808-333ab71acb2di︠
%html
We implement the binary tree sort algorthm in SageMath by first defining a <code>Node</code> in the the tree to contain three components, a key value, a left child and a right child.  This is accomplished with the following code. An expression of the form <code>Node(k)</code> creates a node with key <code>k</code> and no children.
︡785faa04-8b0b-4729-a2eb-91de221609ae︡{"done":true,"html":"We implement the binary tree sort algorthm in SageMath by first defining a <code>Node</code> in the the tree to contain three components, a key value, a left child and a right child.  This is accomplished with the following code. An expression of the form <code>Node(k)</code> creates a node with key <code>k</code> and no children."}
︠2c9d547e-d474-43de-a9a6-d81054ed04ae︠
class Node:
    def __init__(self, keyval=None,Lchild=None,Rchild=None):
        self.key = keyval
        self.left = Lchild
        self.right = Rchild
    def depth(self):
                    if self.left==None and self.right==None:
            return 0
        else:
            if self.left==None:
                return 1+self.right.depth()
            else:
                if self.right==None:
                    return 1+self.left.depth()
                else:
                    return max(self.left.depth(),self.right.depth())

︡65b4756d-941a-4678-a302-5e78a7a5149b︡{"done":true}︡
︠8df12c9f-3805-4206-9b97-f249cebc7bb6i︠
%html
We define the function <code>insert_sort</code> to recursively insert a key value, <code>b</code>, into a tree rooted at <code>r</code>. We will use this function to build a binary tree.  Smaller key values are steered to the left and larger ones to the right.
︡7b2eef92-8d22-4f7f-96b3-a98185ca36f4︡{"done":true,"html":"We define the function <code>insert_sort</code> to recursively insert a key value, <code>b</code>, into a tree rooted at <code>r</code>. We will use this function to build a binary tree.  Smaller key values are steered to the left and larger ones to the right."}
︠65be0b85-e1c1-4ec2-9715-533449f2d0cbs︠
def insert_sort(r,b):
    if b<r.key:
        if r.left==None:
            r.left=Node(b)
        else:
            insert_sort(r.left,b)
    else:
        if r.right==None:
            r.right=Node(b)
        else:
            insert_sort(r.right,b)
︡d5cf6031-ce97-4844-8330-46cf6af3710c︡{"done":true}︡
︠297fd493-4573-484f-9389-b26576efba41i︠
%html
Once the tree is built, we traverse it with the function <code>inorder_traverse</code>, which assembles a sorted list.
︡77518811-4dbd-4ed8-ba7a-2f8bc2473622︡{"done":true,"html":"Once the tree is built, we traverse it with the function <code>inorder_traverse</code>, which assembles a sorted list."}
︠8b4a9202-7040-4238-a5fd-26caf8b55b87s︠
def inorder_traverse(r):
    if r.left!=None:
        ls=inorder_traverse(r.left)
    else:
        ls=[]
    m=r.key
    if r.right!=None:
        rs=inorder_traverse(r.right)
    else:
        rs=[]
    return ls+[m]+rs

︡139a9ba9-b5f2-472a-8888-12abbeb4b8af︡{"done":true}︡
︠c64f4ba9-9ac3-4701-92fb-f833b18857a2i︠
%html We demonstrate the process with a list of integers.
︡aed40fe3-0519-4195-915d-55cc1e5a056e︡{"html":"We demonstrate the process with a list of integers."}︡{"done":true}︡
︠b3cc3255-a493-423e-bf90-3d578c173d87s︠
a=[6953,811,2324,1884,8945,1943,2923,7909,3390,8229,8337,9656,4545,7082,7333,6461,5306,2945,8414,9352,2993,8663,8260,6810,4263]
︡c019dad5-e4b7-4949-ad52-f848997202c3︡{"done":true}︡
︠5ef5fb52-b1ca-4648-a1c1-24630c9c5804i︠
%html  The first number in the list is placed at the root of our tree and then the rest are inserted using <code>insert_sort</code>. Note: In Python (and hence in SageMath), all but the first entry in a list <code>a</code> is most easily specified using <q>slice</q> notation, <code>a[1:]</code>.
︡4641be97-0cbf-4778-b5cf-8cda00ea339d︡{"html":" The first number in the list is placed at the root of our tree and then the rest are inserted using <code>insert_sort</code>. Note: In Python (and hence in SageMath), all but the first entry in a list <code>a</code> is most easily specified using <q>slice</q> notation, <code>a[1:]</code>."}︡{"done":true}︡
︠aa39e6e0-a61b-441b-b97b-b8995986eff0s︠
root=Node(a[0])
for b in a[1:]:
    insert_sort(root,b)
︡20bab8b2-4447-47b0-9804-88951194b58a︡{"done":true}︡
︠1c0eeab2-267b-41d9-8391-6a7539d2f771i︠
%html
Now we traverse the tree to get our sorted list.
︡b0bbb6db-9960-4870-91b6-ff5d05fd50fd︡{"done":true,"html":"Now we traverse the tree to get our sorted list."}
︠2e4df90a-548c-4ca7-9c7f-8e87573e9358s︠
a2=inorder_traverse(root)
a2
︡6eea77bf-b797-4538-9cb8-1ce171d16cad︡{"stdout":"[811, 1884, 1943, 2324, 2923, 2945, 2993, 3390, 4263, 4545, 5306, 6461, 6810, 6953, 7082, 7333, 7909, 8229, 8260, 8337, 8414, 8663, 8945, 9352, 9656]\n"}︡{"done":true}︡

︠2982bc58-2df2-4edd-b9b2-fad86d52c71e︠









